function unroll {
    lines=`expr $1 - 1`
    text=$2
    
    for i in `seq 0 $lines`; do
        for j in `seq 0 $lines`; do
            echo "$text" | sed -e "s/res\[i\]\[j\]/res_${i}_${j}/g" -e "s/\([^a-zA-Z]\)i\([^a-zA-Z]\)/\1$i\2/g" -e "s/\([^a-zA-Z]\)j\([^a-zA-Z]\)/\1$j\2/g"
        done
    done
}




size=8

unroll $size 'float res[i][j] = 0;' 
#unroll $size 'res[i][j] += subh_cache(subh + (i * BLOCK_SIZE) * all.y + (j * BLOCK_SIZE) * all.x);'
#unroll $size 'slice[(idy + BLOCK_SIZE * i) * slice_width + idx + BLOCK_SIZE * j] = res[i][j];'
#unroll $size 'res[i][j] += read_imagef(sinogram, volumeSampler, (float2)(subh + i * BLOCK_SIZE * all.y + j * BLOCK_SIZE * all.x, proj + .5f)).x;'
unroll $size 'slice[(idy + get_local_size(1) * i) * slice_width +  idx + get_local_size(0) * j] = res[i][j];'
unroll $size 'res[i][j] += subh_cache(h + (i * get_local_size(0)) * all.y + (j * get_local_size(0)) * all.x);'
unroll $size 'subh = h + (i * get_local_size(0)) * all.y + (j * get_local_size(0)) * all.x; isubh = floor(subh); v = subh_cache(isubh); res[i][j] += v.x + (subh - isubh) * v.y;'
